#ifndef ATA_H
#define ATA_H

#define EOK             (0)
#define EATA_DEV_FAIL   (1)

#define ATA_UNKNOWN	(0)
#define ATA_PATA	(1)
#define ATA_SATA	(2)
#define ATA_PATAPI	(3)
#define ATA_SATAPI	(4)

#define ATA_PRIMARY_BUS		(1)
#define ATA_SECONDARY_BUS	(2)

struct dev_ata
{
	uint16_t io_base;
	uint16_t ctl_base;
	uint8_t slave;
};

int ata_init(struct dev_ata *dev, int bus, int slave);
int ata_detect(int bus, int slave);
int ata_read(struct dev_ata *dev, uint32_t lba, uint8_t count, unsigned char *buf);
int ata_write(struct dev_ata *dev, uint32_t lba, uint8_t sector_count, unsigned char *buf);

int ata_drive_size(struct dev_ata *ata);

#endif
