#ifndef BLK_DEV_H
#define BLK_DEV_H

#include <stdint.h>
#include "ata.h"

#define EOK		(0)
#define EDEV_ERR	(1)

/** struktura reprezentujici obecne blokove zarizeni */
struct blk_dev
{
	/** velikost bloku v bytech */
	uint32_t block_size;

	/** pocet bloku zarizeni */
	uint32_t block_cnt;

	/** 
	 * z daneho zarizeni precte blk_cnt bloku do pameti specifikovane argumentem buf,
	 * blk_offset udava index prvniho bloku
	 */
	int (*read)(struct blk_dev *dev, unsigned char *buf, uint32_t blk_offset, uint32_t blk_cnt);

	/** 
	 * na dane zarizeni ulozi blk_cnt bloku z pameti specifikovane argumentem buf,
	 * blk_offset udava index prvniho bloku
	 */
	int (*write)(struct blk_dev *dev, unsigned char *buf, uint32_t blk_offset, uint32_t blk_cnt);
};

struct ata_blk_dev
{
	struct blk_dev blk_dev;
	struct dev_ata dev_ata;
};

int blk_dev_detect();

#endif 
