#ifndef KEYB_H
#define KEYB_H

#include <stdint.h>
#include "../tasks/tasks.h"

#define MOD_EXT		(0x01) /* funkcni klavesy, f1, up, down, ... */
#define MOD_SHIFT	(0x02)
#define MOD_CTRL	(0x04)

#define IS_MOD_SHIFT(key_stroke)	((MOD_SHIFT << 8) & (key_stroke))
#define IS_MOD_CTRL(key_stroke)		((MOD_CTRL << 8) & (key_stroke))
#define IS_MOD_EXT(key_stroke)		((MOD_EXT << 8) & (key_stroke))

#define C(x)	((MOD_CTRL << 8) | (x))
#define S(x)	((MOD_SHIFT << 8) | (x))
#define E(x)	((MOD_EXT << 8) | (x))

#define ESCAPE	(0x01)
#define F1	(0x10) 
#define F2	(0x11) 
#define F3	(0x12) 
#define F4	(0x13) 
#define F5	(0x14) 
#define F6	(0x15) 
#define F7	(0x16) 
#define F8	(0x17) 
#define F9	(0x18) 
#define F10	(0x19) 

void keyb_init();
unsigned char keyb_scancode();
uint16_t keyb_get_stroke();
char keyb_getc();

#endif
