/*
 * Command Shell -- jednoduchy shell spoustejici zadane prikazy
 */
#include <stdio.h>
#include <unistd.h>

#define CMD_BUF_SIZE	(65535)
#define MAX_ARG		(255) 
#define DIR_BUF_SIZE	(256)

static inline int _isspace(char c)
{
	return (c == ' ') || (c == '\t') || (c == '\r') || (c == '\n') || (c == '\f');
}

void parse_args(char *cmd, char **args)
{
	int i = 0;
	char *s = cmd;
	while (1) {
		/* preskoci bile znaky */
		while (*s && _isspace(*s)) s++;

		/* konec retezce */
		if (*s == '\0') {
			args[i] = NULL;
			break;
		}
		/* zacatek argumentu */
		args[i++] = s;

		if (i == MAX_ARG) break;

		/* projde vsechny ostatni znaky krome bilych a za ne vlozi \0 */
		while (*s && !_isspace(*s)) s++;
		*s = '\0';
		s++;
	}
}

int main(int argc, char **argv)
{
	/* vstupni buffer, kam je ulozen prikaz */
	static char cmd_buf[CMD_BUF_SIZE];

	/* buffer, kam jsou ulozeny odkazy na jednotlive argumenty */
	static char *args[MAX_ARG + 2]; /* +1 nazev prikazu, +1 NULL */ 

	while (1) {

		printf("sh:> ");
		
		char *cmd = fgets(cmd_buf, CMD_BUF_SIZE, stdin);
		if (cmd) {
			parse_args(cmd_buf, args);
			execv(args[0], args);
			sched_yield();

			/* kdyz se dostane az sem, doslo k chybe */
//			printf("Invalid command: %s\n", args[0]); 
		}
	}
	return argc;
}
