#ifndef VM_H
#define VM_H

#include <stdint.h>

#define PAGE_SIZE      (4096)             /* velikost stranky */
#define KERNEL_MEM_END (0x00200000)       /* horni hranice jadra */

void vm_init(uint32_t pmem_size);
void vm_enable_paging();
uint32_t *vm_create_initial_page_directory();
void vm_pagefault_handler(uint32_t addr, uint32_t flags);
void vm_reclaim(uint32_t *pd);
void vm_set_page_directory(uint32_t *pd);
void vm_reclaim(uint32_t *pd);

#endif
