#include "string.h"

void *memset(void *s, int c, size_t n)
{
	unsigned char *mem = s;
	for (size_t i = 0; i < n; i++) {
		mem[i] = c;	
	}
	return s;
}

void *memcpy(void *dest, const void *src, size_t n)
{
	unsigned char *d = dest;
	const unsigned char *s = src;
	while (n) {
		*d = *s, d++, s++, n--;
	}
	return dest;
}

size_t strlen(const char *s)
{
	size_t len = 0;
	while (*s) {
		s++, len++;
	}
	return len;

}
char *strcpy(char *dest, const char *src)
{
	while ((*dest = *src)) {
		dest++;
		src++;
	}
	return dest;
}


// FIXME: otestovat proti: https://c-for-dummies.com/blog/?p=3873
size_t strlcpy(char *dest, const char *src, size_t n)
{
	size_t i = 0;
	for (i = 0; i < n - 1; i++) {
		if ((dest[i] = src[i]) == '\0')
			return i;
	}
	dest[n - 1] = '\0';
	return i + strlen(src + n); 
}

char *strchrnul(const char *s, int c)
{
	while (1) {
		if ((*s == c) || (*s == '\0'))
			return (char *) s;
		s++;
	}
}

char *strrchr(const char *s, int c)
{
	char *r = NULL;
	while (*s) {
		if (*s == c) r = (char *) s;
		s++;
	}
	return r;
}

char *strchr(const char *s, int c)
{
	while (*s) {
		if (*s == c) return (char *) s;
		s++;
	}
	return NULL;
}

int strcmp(const char *s1, const char *s2)
{
	while (*s1 && (*s1 == *s2)) {
		s1++;
		s2++;
	}

	return *s1 - *s2;
}


